Cu.import("resource://app/modules/gloda/mimemsg.js");
Cu.import("resource://app/modules/gloda/connotent.js");

var rdi_loadStatus = false;
var rdi_initStatus = false;

var rdi_curr = null;
var rdi_isRD = false;

var loadRDfromEmail = true;
var addRDtoEmail = true;

var rdi_main = {

     init : function() {
        if (rdi_initStatus)
            return;

        var defaultRD;
        var offbydefault, contextmenu;
        var initdelay;

        try {
            defaultRD = parseInt(rdi_prefs.getCharPref("defaultrd"));
            offbydefault = rdi_prefs.getBoolPref("offbydefault");
            contextmenu = rdi_prefs.getBoolPref("contextmenu");
            loadRDfromEmail = rdi_prefs.getBoolPref("loadRDfromEmail");
            addRDtoEmail = rdi_prefs.getBoolPref("addRDtoEmail");
        } catch (e) {
            dumpStr('rdi_main.init-> '+e);
            defaultRD = -1;
            offbydefault = false;
            contextmenu = true;
            initdelay = 1000;
        }

        var ctxmenu = document.getElementById("subjects_prefix_switchContext");
        ctxmenu.setAttribute("hidden", !contextmenu);

        if ((defaultRD > -1) || offbydefault) {
           setTimeout("rdi_main.delayedInit(" + defaultRD + ", " + offbydefault + ")", initdelay);
        }

        rdi_initStatus = true;
    },

    subjects_prefix_switch : function() {
        var subjectElement = GetMsgSubjectElement();
        
        subjectElement.editor.beginTransaction();
        
        if (!rdi_isRD && rdi_curr != null) {
            rdi_main.insertRD(subjectElement, rdi_curr);
        } else {
            if (rdi_main.searchRD(subjectElement)) {
                rdi_main.removeRD(subjectElement);
		    }
        }

        /*
         *if (!rdi_isRD && rdi_curr != null) {
            rdi_main.insertRD(subjectElement, rdi_curr);
        } else {
            if (rdi_main.searchRD(subjectElement)) {
                rdi_main.removeRD(subjectElement);
		    }
        }
        */

        SetComposeWindowTitle();
        subjectElement.editor.endTransaction();
    },

    searchRD : function(subjectElement) {
        if (!rdi_curr)
            return false;
        
        var indexOf = subjectElement.value.indexOf(rdi_curr.rd);
        return (indexOf > -1);
    },

    removeRD : function(subjectElement) {
        var start = subjectElement.value.indexOf(rdi_curr.rd);
        var len = rdi_curr.rd.length
        
        subjectElement.value = 
            // 0 - RD
            subjectElement.value.substring(0, start) 
            // RD - koniec z usuniecie spacji po RD
            + (subjectElement.value.substring(start+len).charAt(0) == ' '
                ? subjectElement.value.substring(start + len + 1)
                : subjectElement.value.substring(start + len));
        
       rdi_isRD = false;
    },

    insertRD : function(subjectElement, rd) {
        subjectElement.editor.beginningOfDocument();
        subjectElement.value = rd.rd + ' ' + subjectElement.value;
        
        rdi_curr = rd;
        rdi_isRD = true;

        dumpStr('insertRD->' + rd.rd + ' ' +rd.description);
    },

    loadRD : function(idx, del) {
        var rd = rdi_main.loadRDProperty()[idx];
        
        var subjectElement = GetMsgSubjectElement();
        var currentEditor = subjectElement.editor;
        var initialRange = currentEditor.selection.getRangeAt(0).cloneRange();
        var hasRD = rdi_main.searchRD(subjectElement);
        currentEditor.beginTransaction();

        if (hasRD && del) {
            rdi_main.removeRD(subjectElement);
        }
        rdi_main.insertRD(subjectElement, rd);
        
        SetComposeWindowTitle();
        currentEditor.endTransaction();

        currentEditor.selection.removeAllRanges();
        currentEditor.selection.addRange(initialRange);

        rdi_main.sanitize();
    },

    sanitize : function()  {
        rdi_initStatus = false;
    },

    onLoad : function() {
        if (rdi_loadStatus)
            return;

        rdi_main.ensurePrefs();
        rdi_main.init();
        
        rdi_loadStatus = true;
    },

    ensurePrefs : function() {
        for (var i = 0; i < CONFIGURATION_IDS.length; i++) {
            if (rdi_prefs.getPrefType(CONFIGURATION_IDS[i]) == rdi_prefs.PREF_INVALID)  {
                openOptions(true);
                return;
             }
        }
    },

    delayedInit : function(defaultRD, offbydefault) {
        var hasDefaultRD = defaultRD > -1;
        if (hasDefaultRD && !loadRDfromEmail) {
            rdi_main.initWithDefault(defaultRD, offbydefault);
        }
        if(loadRDfromEmail) {
            rdi_main.loadOriginalMsgSSHeader(defaultRD, offbydefault);
        }
    },

    initWithDefault : function(defaultRD, offbydefault) {
        rdi_curr = rdi_main.loadRDProperty()[defaultRD];
        if (!offbydefault) {
            rdi_main.loadRD(defaultRD, rdi_initStatus);
        }
    },

    initMenuPopup : function(element) {
        var menuPopup = document.getElementById("subjects_prefix_switchMenuPopup-" + element);

        removeMenuItems(menuPopup);

        if (element != "toolbar") {
            rdi_main.insertOnOffItem(menuPopup, getLocalizedMessage("menuItem.onOff"), getLocalizedMessage("toolTip.onOff"));
            menuPopup.appendChild(document.createElement("menuseparator"));
        }

        var rdData = rdi_main.loadRDProperty();

        for (var i = 0; i < rdData.length; i++) {
            rdi_main.insertMenuItem(menuPopup, rdData[i].description, rdData[i].rd, i);
        }

        if (rdData.length > 0) {
            menuPopup.appendChild(document.createElement("menuseparator"));
        }
        
        rdi_main.insertOptionsItem(menuPopup, getLocalizedMessage("menuItem.options"), getLocalizedMessage("toolTip.enterOptions"));
    },

    loadRDProperty : function() {
        return PrefixesListSingleton.getInstance().getPrefixesList();
    },

    addRDEntry : function(rd) {
        var pl = PrefixesListSingleton.getInstance();
        pl.getPrefixesList().push(rd);
        pl.savePrefixesArray();
    },

    insertMenuItem : function(menu, label, tooltip, idx) {
        var item = createMenuItem("subjects_prefix_switch_RD_" + idx, label, tooltip, "rdi_main.loadRD(" + idx + ", true); event.stopPropagation();");
		menu.appendChild(item);
    },

    insertOptionsItem : function(menu, label, tooltip) {
        var item = createMenuItem("subjects_prefix_switch_openOptions", label, tooltip, "openOptions(false); event.stopPropagation();");
		menu.appendChild(item);
    },

    insertOnOffItem : function(menu, label, tooltip) {
        var item = createMenuItem("subjects_prefix_switch_onOff", label, tooltip, "rdi_main.subjects_prefix_switch(); event.stopPropagation();");
		menu.appendChild(item);
    },

	loadOriginalMsgSSHeader : function(defaultRD, offbydefault) {
        dumpStr('-> loadOriginalMsgSSHeader; defaultRD = '+offbydefault+'; defaultRD = '+offbydefault);
        let messenger = Cc["@mozilla.org/messenger;1"].createInstance(Ci.nsIMessenger);
        let msgURI = gMsgCompose.originalMsgURI;
        dumpStr('loadOriginalMsgSSHeader; originalMsgURI->'+msgURI);
        if (msgURI) {
            let msgHdr = messenger.messageServiceFromURI(msgURI).messageURIToMsgHdr(msgURI);

            if (rdi_main.isAddressOnIgnoreList(msgHdr.author) != true) {
                try {
                    MsgHdrToMimeMessage(msgHdr, null, function(aMsgHdr, aMimeMsg) {
                        dumpStr('-> MsgHdrToMimeMessage; aMimeMsg = '+aMimeMsg);
                        if (aMimeMsg == null) /* shouldn't happen, but sometimes does? */
                            return;

                        let item = rdi_main.findSubSwitchHeader(aMimeMsg);

                        if (item != null) {
                            rdi_curr = item;
                            rdi_isRD = true;
                            //rdi_main.subjects_prefix_switch();
                        } else {
                            rdi_main.initWithDefault(defaultRD, offbydefault);
                        }
                        dumpStr('<- MsgHdrToMimeMessage; item = '+item);
                     });
                } catch (e if e.result == Cr.NS_ERROR_FAILURE) {
                    dumpStr('loadOrgMsg; no ssHeader ->' + e);
                }
            }
        }
        dumpStr('<- loadOriginalMsgSSHeader');
    },

    isAddressOnIgnoreList : function(author) {
        dumpStr('-> isAddressOnIgnoreList; author = '+author);
        var result = false;
        dumpStr(author);
        var ignoreList = rdi_prefs.
                getComplexValue("discoveryIgnoreList", Components.interfaces.nsISupportsString).data.split(";");

        if (author.charAt(0) == "\"" && author.charAt(author.length - 1) == "\"")
            author = author.substring(1, author.length - 1);
        if (author.indexOf(">") > -1) {
            let authorStripRegEx = new RegExp("(" + rx_user + "\@" + rx_domain + ")");
            let m = authorStripRegEx.exec(author);
            if (m != null) {
                author = m[0];
            }
        }
        dumpStr(author);
        
        if (ignoreList.length > 0) {
            var validate = new RegExp(rx);
            var match;
            if (validate.test(author)) {
                for (var j = 0; j < ignoreList.length; j++) {
                    if (ignoreList[j].indexOf("?") > -1) {
                        let ignoreTriggerRegEx = new RegExp(ignoreList[j].split("?").join(rx_wildcard));
                        dumpStr(">>>"+ignoreList[j].split("?").join(rx_wildcard));
                        match = ignoreTriggerRegEx.test(author);
                    } else {
                        match = (ignoreList[j].toLowerCase() == author.toLowerCase());
                    }

                    if (match) {
                        result = true;
                        break;
                    }
                }
            }
        }

        dumpStr('<- isAddressOnIgnoreList; result = '+result);
        return result;
    },

    findSubSwitchHeader : function(aMimeMsg) {
        dumpStr('-> findSubSwitchHeader; aMimeMsg = '+aMimeMsg);
        let ssKey, ssDesctiption;
        let remotePrefixItem;
        let ssHeader = aMimeMsg.get(SUBSWITCH_MIME_HEADER);
        dumpStr('parseSubSwitchMimeHeader; ssHeader ->'+ssHeader);

        if (ssHeader) {
            let ssStrings = ssHeader.split(';');
            ssDesctiption = ssStrings[0].trim();
            ssKey = ssStrings[1].trim();
        } else {
            let discoveryPattern = rdi_prefs.getCharPref("discoveryItemPattern");
            let subject = aMimeMsg.get("Subject");
            let re = new RegExp(discoveryPattern);
            let m = re.exec(subject);
            if (m != null) {
                ssKey = m[0];
                ssDesctiption = m[0];
            }
        }

        if (ssKey != null) {
            remotePrefixItem = new PrefixItem(ssDesctiption, ssKey);
            dumpStr('loadOriginalMsgSSHeader; dopasowanie prefiksu remoteSP ->'+remotePrefixItem);

            let idx = rdi_main.loadRDProperty().indexOf(remotePrefixItem);
            let found = (idx >= 0);

            if (!found) {
                if (rdi_main.displayConfirm(remotePrefixItem)) {
                    rdi_main.addRDEntry(remotePrefixItem);
                } else {
                    remotePrefixItem = null;
                }
            } else {
                remotePrefixItem = rdi_main.loadRDProperty()[idx];
            }
        }

        dumpStr('<- findSubSwitchHeader; remotePrefixItem = '+remotePrefixItem);
        return remotePrefixItem;
    },

    displayConfirm : function (remotePrefixItem) {
        var strbundle = document.getElementById("subjects_prefix_switch.locale");

        var title = strbundle.getString("discovery.confirmTitle");
        var msg = strbundle.getString("discovery.confirmMessage");
        var header = strbundle.getString("discovery.confirmHeader");
        var params = Cc["@mozilla.org/embedcomp/dialogparam;1"].createInstance(Ci.nsIDialogParamBlock);
        params.SetNumberStrings(30);
        
        params.SetString(0, msg);
        params.SetString(2, "question-icon");
        params.SetString(3, header);
        params.SetString(12, title);
        
        params.SetString(20, remotePrefixItem.rd);
        params.SetString(21, remotePrefixItem.description);

        window.openDialog("chrome://subjects_prefix_switch/content/prefix_found.xul", null,
            "chrome,centerscreen,modal,dialog,resizable=no", params);

        remotePrefixItem.rd = params.GetString(20);
        remotePrefixItem.description = params.GetString(21);
            
        return params.GetInt(0) == 0 ? true : false;
    },

    onSend : function() {
        dumpStr('-> onSend; addRDtoEmail = '+addRDtoEmail);
        if (addRDtoEmail) {
            try {
                gMsgCompose.compFields.otherRandomHeaders += SUBSWITCH_MIME_HEADER + ": " + rdi_curr.description + "; " + rdi_curr.rd +" \r\n";
                dumpStr(gMsgCompose.compFields.otherRandomHeaders);
            } catch (ex) {
                dumpStr ("ERROR: Cannot add current RD to message\n" + ex + "\r\n");
            }
        }
        dumpStr('<- onSend');
    }
};

window.addEventListener("compose-send-message", rdi_main.onSend, true)
window.addEventListener("load", rdi_main.onLoad, true);
window.addEventListener("compose-window-close", rdi_main.sanitize, true);
window.addEventListener("compose-window-reopen", rdi_main.init, true);
