function createItem(description, rd) {
    this.description = description;
    this.rd = rd;
}

function getLocalizedMessage(msg) {
    return document.getElementById("subjects_prefix_switch.locale").getString(msg);
}

function showMessage(title, msg) {
    var nb = document.getElementById("ssMsg");
    nb.removeAllNotifications();
    
    nb.appendNotification(msg, msg,
        "chrome://global/skin/icons/information-16.png",
        nb.PRIORITY_INFO_MEDIUM, null);
}

function openURL(aURL) {
    var uri = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);
    var protocolSvc = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"].getService(Components.interfaces.nsIExternalProtocolService);

    uri.spec = aURL;
    protocolSvc.loadUrl(uri);
}

function openOptions(autosave) {
    return window.openDialog("chrome://subjects_prefix_switch/content/options.xul",
        "_blank", "chrome, centerscreen, modal, resizable=yes, toolbar", autosave);
}

function dumpStr(str) {
    if (PUBLIC_DIST)
        return;

    var csClass = Cc['@mozilla.org/consoleservice;1'];
    var cs = csClass.getService(Ci.nsIConsoleService);

    cs.logStringMessage((new Date()).getTime() + ": " + str);
}

function fillListboxFromArray(listbox, array) {
    for (var i = 0; i < array.length; i++) {
        if (array[i] != "-")
            listbox.appendItem(array[i], array[i]);
    }
}


function getStringFromListbox(listbox){
    var array = "-";

    if (listbox.getRowCount() > 0) {
        array = getArrayFromListbox(listbox).join(";");
    }
    
    return array;
}

function getArrayFromListbox(listbox){
    var array = new Array();

    if (listbox.getRowCount() > 0) {
        for (var i = 0; i < listbox.getRowCount(); i++){
            array.push(listbox.getItemAtIndex(i).value);
        }
    }
    return array;
}

function getRDEntrySplitSign() {
   var result;
   try {
        result = rdi_prefs.getCharPref("entry_split_sign");
   } catch(e) {
        result = ENTRY_SPLIT_SIGN;
        rdi_prefs.setCharPref("entry_split_sign", result);
   }
   return result;
}

function getRDPrefEntriesSplitSign() {
   var result;
   try {
        result = rdi_prefs.getCharPref("entries_split_sign");
   } catch(e) {
        result = ENTRIES_SPLIT_SIGN;
        rdi_prefs.setCharPref("entries_split_sign", result);
   }
   return result;
}

function removeMenuItems(menu) {
    var children = menu.childNodes;

    for (var i = children.length - 1; i >= 0; i--) {
        menu.removeChild(children[i]);
    }
}

function createMenuItem(id, label, tooltip, oncommand) {
    var item = document.createElement("menuitem");

    item.setAttribute("id", id);
    item.setAttribute("label", label);
    item.setAttribute("tooltiptext", tooltip);
    item.setAttribute("oncommand", oncommand);
    item.setAttribute("disabled", false);

    return item;
}

